// AnalCA.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "VectorList.h"

bool ca[127][65][256];
int equ[256],mir[256],inv[256],imir[256];

void ParceText(CString& fn, int i)
{
	CStdioFile f(fn,CFile::modeRead|CFile::typeText);
	char c;
	for (int step=0; step<65; step++) {
		for (int cell=0; cell<127; cell++) {
			f.Read(&c,1);
			ca[cell][step][i]=(c=='0'?false:true);
		}
		f.Read(&c,1);
		f.Read(&c,1);
	}
	f.Close();
}

int stepoff[]={ 0, 1, 1, 1, 0,-1,-1,-1, 0};
int celloff[]={ 0, 1, 0,-1,-1,-1, 0, 1, 1};

bool Test(int i,int j,bool mirror,bool inverse,int offset,int diffs=0)
{
	int res=0,temp;
	for (int step=1+(stepoff[offset]<0)?1:0; max(step,step+stepoff[offset])<65; step++) {
		for (int cell=(celloff[offset]<0)?1:0; cell<127; cell++) {
			temp=(mirror?(126-cell):cell)+celloff[offset];
			if (temp<=126 && temp>=0) {
				if ((inverse?(ca[cell][step][i]):(!ca[cell][step][i]))==ca[temp][step+stepoff[offset]][j]) {
					res++;
					if (res>diffs) return false;
				}
			} /* out of bound otherwise */
		}
	}

	if (!mirror && !inverse) {
		if (equ[i]<0) equ[i]=i;
		if (equ[j]<0) equ[j]=i;
	} else
	if (mirror && !inverse) {
		if (mir[i]<0) mir[i]=i;
		if (mir[j]<0) mir[j]=i;
	} else
	if (!mirror && inverse) {
		if (inv[i]<0) inv[i]=i;
		if (inv[j]<0) inv[j]=i;
	} else
	if (mirror && inverse) {
		if (imir[i]<0) imir[i]=i;
		if (imir[j]<0) imir[j]=i;
	}
	return true;
}

int main(int, char*)
{
	// Read data to memory
	CString s="";
	CString fn="";
	int i=0,j=0;
	printf("Analisys started\nData is loading: ");
	for (i=0;i<256;i++) {
		s.Format("%d",i);
		while (s.GetLength()<3) s='0'+s;
		fn.Format("..\\Pics\\%s.txt",s);
		ParceText(fn,i);
		equ[i]=-1;
		mir[i]=-1;
		inv[i]=-1;
		imir[i]=-1;
		if (i%5==0) printf(".");
	}
	printf("\nData have been stored in memory\n");

	// Begin to analyze
	int offset=0;
	int offsets=1;
	for (i=0;i<256;i++) for (j=i+1;j<256;j++) {
		for (offset=0; offset<offsets; offset++) if (Test(i,j,false,false,offset)) printf("%d equal %d\n",                i,j);
		for (offset=0; offset<offsets; offset++) if (Test(i,j,true ,false,offset)) printf("%d is mirror of %d\n",         i,j);
		for (offset=0; offset<offsets; offset++) if (Test(i,j,false,true ,offset)) printf("%d is inversed %d\n",          i,j);
		for (offset=0; offset<offsets; offset++) if (Test(i,j,true ,true ,offset)) printf("%d is inversed mirror of %d\n",i,j);
	}

	// Equality output
	VectorList eq;
	eq.Fill();
	CStdioFile f("..\\Pics\\E.txt",CFile::modeCreate|CFile::modeWrite|CFile::typeText);
	for (i=0;i<256;i++) {
		if (equ[i]>=0 && equ[i]!=i) {
			eq.Unite(eq.Find(i),eq.Find(equ[i]));
		}
	}	
	eq.Print(f);
	f.Close();

	f.Open("..\\Pics\\E.tab",CFile::modeCreate|CFile::modeWrite|CFile::typeText);
	eq.PrintTable(f);
	f.Close();

	// Mirror output
	VectorList mr(eq);
	VectorList classes(eq);
	f.Open("..\\Pics\\EM.txt",CFile::modeCreate|CFile::modeWrite|CFile::typeText);
	for (i=0;i<256;i++) {
		if (mir[i]>=0 && mir[i]!=i) {
			mr.Unite(mr.Find(i),mr.Find(mir[i]));
			classes.Unite(classes.Find(i),classes.Find(mir[i]));
		}
	}	
	mr.Print(f);
	f.Close();

	f.Open("..\\Pics\\EM.tab",CFile::modeCreate|CFile::modeWrite|CFile::typeText);
	mr.PrintTable(f);
	f.Close();

	// Inverse output
	VectorList in(eq);
	f.Open("..\\Pics\\EI.txt",CFile::modeCreate|CFile::modeWrite|CFile::typeText);
	for (i=0;i<256;i++) {
		if (inv[i]>=0 && inv[i]!=i) {
			in.Unite(in.Find(i),in.Find(inv[i]));
			classes.Unite(classes.Find(i),classes.Find(inv[i]));
		}
	}	
	in.Print(f);
	f.Close();

	f.Open("..\\Pics\\EI.tab",CFile::modeCreate|CFile::modeWrite|CFile::typeText);
	in.PrintTable(f);
	f.Close();

	// Inversed mirror output
	VectorList im(eq);
	f.Open("..\\Pics\\E(I+M).txt",CFile::modeCreate|CFile::modeWrite|CFile::typeText);
	for (i=0;i<256;i++) {
		if (imir[i]>=0 && imir[i]!=i) {
			im.Unite(im.Find(i),im.Find(imir[i]));
			classes.Unite(classes.Find(i),classes.Find(imir[i]));
		}
	}	
	im.Print(f);
	f.Close();

	f.Open("..\\Pics\\E(I+M).tab",CFile::modeCreate|CFile::modeWrite|CFile::typeText);
	im.PrintTable(f);
	f.Close();

	// Classes without offsets output
	f.Open("..\\Pics\\EIM.txt",CFile::modeCreate|CFile::modeWrite|CFile::typeText);
	classes.Print(f);
	f.Close();

	f.Open("..\\Pics\\EIM.tab",CFile::modeCreate|CFile::modeWrite|CFile::typeText);
	classes.PrintTable(f);
	f.Close();

	return 0;
}