// VectorList.cpp: implementation of the VectorList class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "VectorList.h"

void Copy(list<int>::iterator first, list<int>::iterator last, list<int>& x)
{
	for (list<int>::iterator it=first; it!=last; it++) x.push_back(*it);
}	

void VectorList::Print(CStdioFile& f)
{
	for (int i=0;i<256;i++) if (!(*this)[i].empty()) {
		for (list<int>::iterator it=(*this)[i].begin(); it!=(*this)[i].end(); it++) {
			CString s;
			if (it!=(*this)[i].begin()) s.Format(" %d",*it); else s.Format("%d",*it);
			f.WriteString(s);
		}
		f.WriteString("\n");
	}
}

void VectorList::PrintTable(CStdioFile& f)
{
	unsigned char cls=0,cur=0;;
	CString buf[256];
	for (int i=0;i<256;i++) if (!(*this)[i].empty()) {
		cur=(*this)[i].front();
		buf[cur].Format("%d (%d)\n",cls,(*this)[i].size());
		cls++;
		for (list<int>::iterator it=++(*this)[i].begin(); it!=(*this)[i].end(); it++) {
			buf[*it].Format("%d\n",cur);
		}
	}

	for (i=0;i<256;i++) {
		f.WriteString(buf[i]);
	}
}

void VectorList::Unite(int i,int j)
{
	if (i==j) return;
	if (j<i) {
		int t=i;
		i=j;
		j=t;
	}
	Copy((*this)[j].begin(),(*this)[j].end(),(*this)[i]);
	(*this)[j].clear();
	unique(++((*this)[i].begin()),(*this)[i].end());
	(*this)[i].sort();
}

int VectorList::Find(int what)
{
	for (int i=0;i<256;i++) if (!(*this)[i].empty()) {
		for (list<int>::iterator it=(*this)[i].begin(); it!=(*this)[i].end(); it++) {
			if (*it==what) return i;
		}
	}
	return 256;
}
